"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RawAtom = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = require("@emotion/react");

var _excluded = ["css", "element", "getColor", "location", "theme", "changeTheme", "atomRef", "touchDetected"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Atom = function Atom(_ref) {
  var css = _ref.css,
      Element = _ref.element,
      getColor = _ref.getColor,
      location = _ref.location,
      theme = _ref.theme,
      changeTheme = _ref.changeTheme,
      atomRef = _ref.atomRef,
      touchDetected = _ref.touchDetected,
      rest = _objectWithoutProperties(_ref, _excluded);

  return (0, _react.jsx)(Element, _extends({}, rest, {
    css: css,
    ref: atomRef
  }));
};

Atom.propTypes = {
  atomRef: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].shape({})]),
  css: _propTypes["default"].oneOfType([_propTypes["default"].shape({}), _propTypes["default"].func]),
  element: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].string])
};
Atom.defaultProps = {
  atomRef: null,
  css: null,
  element: 'div'
};
Atom.displayName = 'Atom';
var RawAtom = Atom;
exports.RawAtom = RawAtom;
var _default = Atom;
exports["default"] = _default;