"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RawBage = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Paper = _interopRequireDefault(require("../Paper"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _excluded = ["fitAll", "fitLeft", "fitRight"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Bage = function Bage(_ref) {
  var fitAll = _ref.fitAll,
      fitLeft = _ref.fitLeft,
      fitRight = _ref.fitRight,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({
    rounded: true,
    overline: true,
    nowrap: true
  }, rest));
};

Bage.displayName = 'Bage';
Bage.propTypes = {
  /** Reset Margins */
  fitAll: _propTypes["default"].bool,

  /** Reset Left Margin */
  fitLeft: _propTypes["default"].bool,

  /** Reset Right Margin */
  fitRight: _propTypes["default"].bool
};
Bage.defaultProps = {
  fitAll: false,
  fitLeft: false,
  fitRight: false
};
var RawBage = Bage;
exports.RawBage = RawBage;

var _default = (0, _withStyle["default"])(Bage);

exports["default"] = _default;