"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _css = _interopRequireDefault(require("../../util/css"));

var _color = require("../../Theme/color");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = (0, _css["default"])({
  defaultStyle: {
    border: '0',
    height: '0',
    borderTop: "1px solid ".concat(_color.divider)
  },
  dotted: {
    borderStyle: 'dotted'
  },
  baseline: {
    margin: 0,
    paddingTop: 0,
    paddingLeft: 0,
    paddingBottom: 0,
    paddingRight: 0
  },
  inset: {
    marginLeft: '72px'
  },
  invisible: {
    visibility: 'hidden'
  }
});

exports["default"] = _default;