"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Atom = _interopRequireDefault(require("../../atoms/Atom"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _Wave = _interopRequireDefault(require("./Wave"));

var _excluded = ["created", "released"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getBounds = function getBounds(_ref) {
  var target = _ref.target;
  var clientHeight = target.clientHeight,
      clientWidth = target.clientWidth;

  var _target$getBoundingCl = target.getBoundingClientRect(),
      top = _target$getBoundingCl.top,
      left = _target$getBoundingCl.left;

  return {
    height: clientHeight,
    width: clientWidth,
    top: top,
    left: left
  };
};

var Ripple = /*#__PURE__*/function (_Component) {
  _inherits(Ripple, _Component);

  var _super = _createSuper(Ripple);

  function Ripple() {
    var _this;

    _classCallCheck(this, Ripple);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      outline: null,
      waves: []
    });

    _defineProperty(_assertThisInitialized(_this), "makeTransitionHandler", function (created) {
      return function () {
        return _this.setState(function (_ref2) {
          var waves = _ref2.waves;
          return {
            waves: waves.filter(function (wave) {
              return wave.created !== created;
            })
          };
        });
      };
    });

    _defineProperty(_assertThisInitialized(_this), "pushEvent", function (event) {
      var _getBounds = getBounds(event),
          left = _getBounds.left,
          top = _getBounds.top,
          width = _getBounds.width,
          height = _getBounds.height;

      var size = Math.pow(Math.pow(width, 2) + Math.pow(height, 2), 0.5) * 2;
      var halfSize = size / 2;

      _this.pushWawe({
        created: performance.now(),
        css: {
          backgroundColor: _this.backgroundColor,
          left: "".concat(event.clientX - left - halfSize, "px"),
          top: "".concat(event.clientY - top - halfSize, "px"),
          zIndex: 2
        },
        released: false,
        size: size
      });
    });

    _defineProperty(_assertThisInitialized(_this), "release", function () {
      _this.setState(function (_ref3) {
        var waves = _ref3.waves;
        return {
          waves: waves.map(function (wave) {
            return _objectSpread(_objectSpread({}, wave), {}, {
              released: true
            });
          })
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "removeFocus", function () {
      return _this.setState({
        outline: null
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setFocus", function (event, _ref4) {
      var current = _ref4.current;
      if (!current) return;

      var _current$getBoundingC = current.getBoundingClientRect(),
          innerWidth = _current$getBoundingC.width,
          innerHeight = _current$getBoundingC.height;

      var _getBounds2 = getBounds(event),
          width = _getBounds2.width,
          height = _getBounds2.height;

      var size = Math.max(innerHeight, innerWidth, 32);
      var halfSize = size / 2;

      _this.setState(function (_ref5) {
        var waves = _ref5.waves;
        if (waves.length) return null;
        return {
          outline: {
            css: {
              backgroundColor: _this.backgroundColor,
              left: "".concat(width / 2 - halfSize, "px"),
              top: "".concat(height / 2 - halfSize, "px"),
              transform: "translate(-".concat(size, "px, -").concat(size, "px)"),
              zIndex: 2
            },
            size: size
          }
        };
      });
    });

    return _this;
  }

  _createClass(Ripple, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      window.addEventListener('mouseup', this.release);
      window.addEventListener('pointercancel', this.release);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('mouseup', this.release);
      window.removeEventListener('pointercancel', this.release);
    }
  }, {
    key: "backgroundColor",
    get: function get() {
      var _this$props = this.props,
          color = _this$props.color,
          getColor = _this$props.getColor;
      return getColor(color);
    }
  }, {
    key: "outline",
    get: function get() {
      var _this$state = this.state,
          outline = _this$state.outline,
          waves = _this$state.waves;
      if (!outline || waves.length) return null;
      return /*#__PURE__*/_react["default"].createElement(_Wave["default"], outline);
    }
  }, {
    key: "waves",
    get: function get() {
      var _this2 = this;

      return this.state.waves.map(function (_ref6) {
        var created = _ref6.created,
            released = _ref6.released,
            wave = _objectWithoutProperties(_ref6, _excluded);

        return /*#__PURE__*/_react["default"].createElement(_Wave["default"], _extends({
          key: created
        }, wave, {
          onDissolve: _this2.makeTransitionHandler(created),
          released: released
        }));
      });
    }
  }, {
    key: "pushWawe",
    value: function pushWawe(wawe) {
      this.setState(function (_ref7) {
        var waves = _ref7.waves;
        return {
          waves: waves.concat(wawe)
        };
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state2 = this.state,
          outline = _this$state2.outline,
          waves = _this$state2.waves;
      if (!this.props.forceShow && !outline && !waves.length) return null;
      return /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
        element: "span",
        css: {
          background: 'none',
          borderRadius: 'inherit',
          display: 'block',
          overflow: 'hidden',
          pointerEvents: 'none',
          position: 'absolute',
          top: 0,
          left: 0,
          right: 0,
          bottom: 0
        }
      }, /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
        element: "span",
        css: _objectSpread({
          backgroundColor: this.backgroundColor
        }, this.props.css)
      }), this.waves, this.outline);
    }
  }]);

  return Ripple;
}(_react.Component);

Ripple.displayName = 'Ripple';
Ripple.propTypes = {
  color: _propTypes["default"].string,
  getColor: _propTypes["default"].func.isRequired,
  css: _propTypes["default"].shape().isRequired,
  forceShow: _propTypes["default"].bool
};
Ripple.defaultProps = {
  color: null,
  forceShow: false
};

var _default = (0, _withStyle["default"])(Ripple);

exports["default"] = _default;