"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _css = _interopRequireDefault(require("../../util/css"));

var _color = require("../../Theme/color");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = (0, _css["default"])({
  defaultStyle: {
    alignItems: 'center',
    borderWidth: 0,
    borderColor: _color.text,
    cursor: 'pointer',
    display: 'inline-flex',
    height: '48px',
    justifyContent: 'center',
    minHeight: '48px',
    outline: 'none',
    paddingTop: 0,
    paddingBottom: 0,
    paddingLeft: '16px',
    paddingRight: '16px',
    WebkitTapHighlightColor: 'transparent',
    tapHighlightColor: 'transparent',
    userSelect: 'none'
  },
  autoHeight: {
    height: 'auto'
  },
  blockLevel: {
    display: 'flex',
    width: '100%'
  },
  fitAll: {
    paddingBottom: 0,
    paddingTop: 0,
    paddingLeft: 0,
    paddingRight: 0
  },
  fitLeft: {
    paddingLeft: 0
  },
  fitRight: {
    paddingRight: 0
  },
  large: {
    height: '56px',
    minHeight: '56px',
    paddingLeft: '32px',
    paddingRight: '32px'
  },
  outline: {
    background: 'transparent',
    border: '2px solid',
    boxSizing: 'border-box'
  },
  small: {
    height: '32px',
    minHeight: '32px',
    paddingLeft: '8px',
    paddingRight: '8px'
  },
  vertical: {
    flexDirection: 'column'
  }
});

exports["default"] = _default;