"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var createMediaCss = function createMediaCss(css, mediaQueries) {
  return Object.keys(css).reduce(function (acc, currentKey) {
    var query = mediaQueries[currentKey];
    var key = query ? "@media ".concat(query) : currentKey;
    return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, key, css[currentKey]));
  }, {});
};

var _default = function _default(css) {
  return function (_ref) {
    var mediaQueries = _ref.mediaQueries,
        theme = _ref.theme;
    return createMediaCss(css, mediaQueries || theme.mediaQueries);
  };
};

exports["default"] = _default;