"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SimpleButton = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Context = _interopRequireDefault(require("../../Theme/Context"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _Paper = _interopRequireDefault(require("../../atoms/Paper"));

var _Ripple = _interopRequireDefault(require("../../fx/Ripple/Ripple"));

var _Spinner = _interopRequireDefault(require("../Spinner"));

var _wrapChild = _interopRequireDefault(require("./wrapChild"));

var _excluded = ["width", "height", "minHeight"],
    _excluded2 = ["autoHeight", "blockLevel", "busy", "children", "css", "color", "element", "fitAll", "fitLeft", "fitRight", "large", "noRipple", "onPointerDown", "onPointerUp", "outline", "round", "small", "spinnerProps", "vertical"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Button = /*#__PURE__*/function (_Component) {
  _inherits(Button, _Component);

  var _super = _createSuper(Button);

  function Button() {
    var _this;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      hasHighlight: false
    });

    _defineProperty(_assertThisInitialized(_this), "contentRef", /*#__PURE__*/(0, _react.createRef)());

    _defineProperty(_assertThisInitialized(_this), "rippleRef", /*#__PURE__*/(0, _react.createRef)());

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function () {
      var current = _this.rippleRef.current;
      if (current) current.removeFocus();
    });

    _defineProperty(_assertThisInitialized(_this), "handleFocus", function (event) {
      var current = _this.rippleRef.current;
      if (current) current.setFocus(event, _this.contentRef);
    });

    _defineProperty(_assertThisInitialized(_this), "handleMouseEnter", function () {
      _this.setState({
        hasHighlight: !_this.context.touchDetected
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleMouseLeave", function () {
      return _this.setState({
        hasHighlight: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDown", function (event) {
      var current = _this.rippleRef.current;
      if (current) current.pushEvent(event);

      _this.props.onPointerDown(event);
    });

    _defineProperty(_assertThisInitialized(_this), "handleUp", function (event) {
      var current = _this.rippleRef.current;
      if (current) current.release(event);

      _this.props.onPointerUp(event);
    });

    return _this;
  }

  _createClass(Button, [{
    key: "css",
    get: function get() {
      var _this$props = this.props,
          css = _this$props.css,
          round = _this$props.round;

      if (round) {
        var width = css.width,
            height = css.height,
            minHeight = css.minHeight,
            rest = _objectWithoutProperties(css, _excluded);

        return _objectSpread(_objectSpread({}, rest), {}, {
          paddingTop: 0,
          paddingLeft: 0,
          paddingBottom: 0,
          paddingRight: 0
        });
      }

      return css;
    }
  }, {
    key: "content",
    get: function get() {
      var _this$props2 = this.props,
          busy = _this$props2.busy,
          children = _this$props2.children;
      return _react.Children.map(children, (0, _wrapChild["default"])(busy));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          autoHeight = _this$props3.autoHeight,
          blockLevel = _this$props3.blockLevel,
          busy = _this$props3.busy,
          children = _this$props3.children,
          css = _this$props3.css,
          color = _this$props3.color,
          element = _this$props3.element,
          fitAll = _this$props3.fitAll,
          fitLeft = _this$props3.fitLeft,
          fitRight = _this$props3.fitRight,
          large = _this$props3.large,
          noRipple = _this$props3.noRipple,
          onPointerDown = _this$props3.onPointerDown,
          onPointerUp = _this$props3.onPointerUp,
          outline = _this$props3.outline,
          round = _this$props3.round,
          small = _this$props3.small,
          spinnerProps = _this$props3.spinnerProps,
          vertical = _this$props3.vertical,
          rest = _objectWithoutProperties(_this$props3, _excluded2);

      var _this$state = this.state,
          hasFocus = _this$state.hasFocus,
          hasHighlight = _this$state.hasHighlight;
      return /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({
        button: true,
        element: element,
        tabIndex: 0,
        atomRef: this.contentRef,
        color: color
      }, rest, {
        css: this.css,
        onBlur: this.handleBlur,
        onFocus: this.handleFocus,
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave,
        onPointerDown: this.handleDown,
        onPointerUp: this.handleUp,
        round: round
      }), !noRipple && /*#__PURE__*/_react["default"].createElement(_Ripple["default"], _extends({}, rest, {
        color: color,
        highlight: hasHighlight,
        forceShow: hasHighlight,
        focus: hasFocus,
        ref: this.rippleRef
      })), this.content, busy && /*#__PURE__*/_react["default"].createElement(_Spinner["default"], _extends({
        blockLevel: true,
        color: color
      }, spinnerProps)));
    }
  }]);

  return Button;
}(_react.Component);

Button.displayName = 'Button';
Button.contextType = _Context["default"];
Button.propTypes = {
  /** height: auto */
  autoHeight: _propTypes["default"].bool,

  /** display: block */
  blockLevel: _propTypes["default"].bool,

  /** Enables spinner state */
  busy: _propTypes["default"].bool,

  /** Button content */
  children: _propTypes["default"].node.isRequired,

  /** Sets color for texts and borders */
  color: _propTypes["default"].string,

  /** Custom styling */
  css: _propTypes["default"].shape(),

  /** Change dom element */
  element: _propTypes["default"].node,

  /** Disable paddings */
  fitAll: _propTypes["default"].bool,

  /** Disable left padding  */
  fitLeft: _propTypes["default"].bool,

  /** Disable right padding  */
  fitRight: _propTypes["default"].bool,

  /** Large size  */
  large: _propTypes["default"].bool,

  /** Disable ripple effect  */
  noRipple: _propTypes["default"].bool,
  onPointerDown: _propTypes["default"].func,
  onPointerUp: _propTypes["default"].func,

  /** Otlined mode  */
  outline: _propTypes["default"].bool,

  /** Rounds button  */
  round: _propTypes["default"].bool,

  /** Required   */
  size: function size(props, propName) {
    if (props.round === true && props[propName] === undefined) {
      return typeof props[propName] === 'number' ? new Error('Please provide a size!') : new Error('Size should be a number');
    }

    return undefined;
  },

  /** Small size  */
  small: _propTypes["default"].bool,

  /** Spinner props  */
  spinnerProps: _propTypes["default"].shape(),

  /** Render children vertically  */
  vertical: _propTypes["default"].bool
};
Button.defaultProps = {
  autoHeight: false,
  blockLevel: false,
  busy: false,
  color: null,
  css: {},
  element: 'button',
  fitAll: false,
  fitLeft: false,
  fitRight: false,
  large: false,
  noRipple: false,
  onPointerDown: function onPointerDown() {},
  onPointerUp: function onPointerUp() {},
  outline: false,
  round: false,
  size: null,
  small: false,
  spinnerProps: null,
  vertical: false
};
var SimpleButton = Button;
exports.SimpleButton = SimpleButton;

var _default = (0, _withStyle["default"])(Button);

exports["default"] = _default;