"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _css = _interopRequireDefault(require("../../../../util/css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = (0, _css["default"])({
  defaultStyle: {
    display: 'flex',
    flexDirection: 'column',
    flexGrow: 1,
    paddingTop: '12px',
    paddingBottom: '12px',
    paddingLeft: '16px',
    paddingRight: '16px'
  },
  center: {
    alignItems: 'center'
  },
  fitAll: {
    paddingTop: 0,
    paddingLeft: 0,
    paddingBottom: 0,
    paddingRight: 0
  },
  fitLeft: {
    paddingLeft: 0
  },
  fitBottom: {
    paddingBottom: 0
  },
  fitTop: {
    paddingTop: 0
  },
  fitRight: {
    paddingRight: 0
  },
  reverse: {
    flexDirection: 'column-reverse'
  },
  small: {
    paddingTop: '4px',
    paddingBottom: '4px'
  }
});

exports["default"] = _default;